# ory_client_client
Documentation for all public and administrative Ory APIs. Administrative APIs can only be accessed
with a valid Personal Access Token. Public APIs are mostly used in browsers.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.0.1-alpha.1
- Build package: org.openapitools.codegen.languages.DartClientCodegen

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  ory_client_client:
    git: https://github.com/ory/sdk.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  ory_client_client:
    path: /path/to/ory_client_client
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_client_client/api.dart';

// TODO Configure HTTP Bearer authorization: oryToken
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('oryToken').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('oryToken').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DefaultApi();
final createIdentity = CreateIdentity(); // CreateIdentity | 

try {
    final result = api_instance.createIdentityAdmin(createIdentity);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->createIdentityAdmin: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *https://playground.projects.oryapis.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**createIdentityAdmin**](doc//DefaultApi.md#createidentityadmin) | **POST** /api/kratos/admin/identities | Create an Identity
*DefaultApi* | [**createRecoveryLinkAdmin**](doc//DefaultApi.md#createrecoverylinkadmin) | **POST** /api/kratos/admin/recovery/link | Create a Recovery Link
*DefaultApi* | [**deleteIdentityAdmin**](doc//DefaultApi.md#deleteidentityadmin) | **DELETE** /api/kratos/admin/identities/{id} | Delete an Identity
*DefaultApi* | [**getIdentityAdmin**](doc//DefaultApi.md#getidentityadmin) | **GET** /api/kratos/admin/identities/{id} | Get an Identity
*DefaultApi* | [**getSchema**](doc//DefaultApi.md#getschema) | **GET** /api/kratos/public/schemas/{id} | 
*DefaultApi* | [**getSchemaAdmin**](doc//DefaultApi.md#getschemaadmin) | **GET** /api/kratos/admin/schemas/{id} | 
*DefaultApi* | [**getSelfServiceError**](doc//DefaultApi.md#getselfserviceerror) | **GET** /api/kratos/public/self-service/errors | Get User-Facing Self-Service Errors
*DefaultApi* | [**getSelfServiceErrorAdmin**](doc//DefaultApi.md#getselfserviceerroradmin) | **GET** /api/kratos/admin/self-service/errors | Get User-Facing Self-Service Errors
*DefaultApi* | [**getSelfServiceLoginFlow**](doc//DefaultApi.md#getselfserviceloginflow) | **GET** /api/kratos/public/self-service/login/flows | Get Login Flow
*DefaultApi* | [**getSelfServiceLoginFlowAdmin**](doc//DefaultApi.md#getselfserviceloginflowadmin) | **GET** /api/kratos/admin/self-service/login/flows | Get Login Flow
*DefaultApi* | [**getSelfServiceRecoveryFlow**](doc//DefaultApi.md#getselfservicerecoveryflow) | **GET** /api/kratos/public/self-service/recovery/flows | Get information about a recovery flow
*DefaultApi* | [**getSelfServiceRecoveryFlowAdmin**](doc//DefaultApi.md#getselfservicerecoveryflowadmin) | **GET** /api/kratos/admin/self-service/recovery/flows | Get information about a recovery flow
*DefaultApi* | [**getSelfServiceRegistrationFlow**](doc//DefaultApi.md#getselfserviceregistrationflow) | **GET** /api/kratos/public/self-service/registration/flows | Get Registration Flow
*DefaultApi* | [**getSelfServiceRegistrationFlowAdmin**](doc//DefaultApi.md#getselfserviceregistrationflowadmin) | **GET** /api/kratos/admin/self-service/registration/flows | Get Registration Flow
*DefaultApi* | [**getSelfServiceSettingsFlow**](doc//DefaultApi.md#getselfservicesettingsflow) | **GET** /api/kratos/public/self-service/settings/flows | Get Settings Flow
*DefaultApi* | [**getSelfServiceSettingsFlowAdmin**](doc//DefaultApi.md#getselfservicesettingsflowadmin) | **GET** /api/kratos/admin/self-service/settings/flows | Get Settings Flow
*DefaultApi* | [**getSelfServiceVerificationFlow**](doc//DefaultApi.md#getselfserviceverificationflow) | **GET** /api/kratos/public/self-service/verification/flows | Get Verification Flow
*DefaultApi* | [**getSelfServiceVerificationFlowAdmin**](doc//DefaultApi.md#getselfserviceverificationflowadmin) | **GET** /api/kratos/admin/self-service/verification/flows | Get Verification Flow
*DefaultApi* | [**getVersionAdmin**](doc//DefaultApi.md#getversionadmin) | **GET** /api/kratos/admin/version | Return Running Software Version.
*DefaultApi* | [**initializeSelfServiceBrowserLogoutFlow**](doc//DefaultApi.md#initializeselfservicebrowserlogoutflow) | **GET** /api/kratos/public/self-service/browser/flows/logout | Initialize Browser-Based Logout User Flow
*DefaultApi* | [**initializeSelfServiceLoginViaAPIFlow**](doc//DefaultApi.md#initializeselfserviceloginviaapiflow) | **GET** /api/kratos/public/self-service/login/api | Initialize Login Flow for API clients
*DefaultApi* | [**initializeSelfServiceLoginViaBrowserFlow**](doc//DefaultApi.md#initializeselfserviceloginviabrowserflow) | **GET** /api/kratos/public/self-service/login/browser | Initialize Login Flow for browsers
*DefaultApi* | [**initializeSelfServiceRecoveryViaAPIFlow**](doc//DefaultApi.md#initializeselfservicerecoveryviaapiflow) | **GET** /api/kratos/public/self-service/recovery/api | Initialize Recovery Flow for API Clients
*DefaultApi* | [**initializeSelfServiceRecoveryViaBrowserFlow**](doc//DefaultApi.md#initializeselfservicerecoveryviabrowserflow) | **GET** /api/kratos/public/self-service/recovery/browser | Initialize Recovery Flow for Browser Clients
*DefaultApi* | [**initializeSelfServiceRegistration**](doc//DefaultApi.md#initializeselfserviceregistration) | **GET** /api/kratos/public/self-service/registration/api | Initialize Registration Flow for API clients
*DefaultApi* | [**initializeSelfServiceRegistrationForBrowsers**](doc//DefaultApi.md#initializeselfserviceregistrationforbrowsers) | **GET** /api/kratos/public/self-service/registration/browser | Initialize Registration Flow for browsers
*DefaultApi* | [**initializeSelfServiceSettingsViaAPIFlow**](doc//DefaultApi.md#initializeselfservicesettingsviaapiflow) | **GET** /api/kratos/public/self-service/settings/api | Initialize Settings Flow for API Clients
*DefaultApi* | [**initializeSelfServiceSettingsViaBrowserFlow**](doc//DefaultApi.md#initializeselfservicesettingsviabrowserflow) | **GET** /api/kratos/public/self-service/settings/browser | Initialize Settings Flow for Browsers
*DefaultApi* | [**initializeSelfServiceVerificationViaAPIFlow**](doc//DefaultApi.md#initializeselfserviceverificationviaapiflow) | **GET** /api/kratos/public/self-service/verification/api | Initialize Verification Flow for API Clients
*DefaultApi* | [**initializeSelfServiceVerificationViaBrowserFlow**](doc//DefaultApi.md#initializeselfserviceverificationviabrowserflow) | **GET** /api/kratos/public/self-service/verification/browser | Initialize Verification Flow for Browser Clients
*DefaultApi* | [**isAliveAdmin**](doc//DefaultApi.md#isaliveadmin) | **GET** /api/kratos/admin/health/alive | Check HTTP Server Status
*DefaultApi* | [**isReadyAdmin**](doc//DefaultApi.md#isreadyadmin) | **GET** /api/kratos/admin/health/ready | Check HTTP Server and Database Status
*DefaultApi* | [**listIdentitiesAdmin**](doc//DefaultApi.md#listidentitiesadmin) | **GET** /api/kratos/admin/identities | List Identities
*DefaultApi* | [**prometheusAdmin**](doc//DefaultApi.md#prometheusadmin) | **GET** /api/kratos/admin/metrics/prometheus | Get snapshot metrics from the Hydra service. If you're using k8s, you can then add annotations to your deployment like so:
*DefaultApi* | [**revokeSession**](doc//DefaultApi.md#revokesession) | **DELETE** /api/kratos/public/sessions | Initialize Logout Flow for API Clients - Revoke a Session
*DefaultApi* | [**submitSelfServiceLoginFlow**](doc//DefaultApi.md#submitselfserviceloginflow) | **POST** /api/kratos/public/self-service/login | Submit a Login Flow
*DefaultApi* | [**submitSelfServiceRecoveryFlow**](doc//DefaultApi.md#submitselfservicerecoveryflow) | **POST** /api/kratos/public/self-service/recovery | Complete Recovery Flow
*DefaultApi* | [**submitSelfServiceRecoveryFlowWithLinkMethod**](doc//DefaultApi.md#submitselfservicerecoveryflowwithlinkmethod) | **POST** /api/kratos/public/self-service/recovery/methods/link | Complete Recovery Flow with Link Method
*DefaultApi* | [**submitSelfServiceRegistrationFlow**](doc//DefaultApi.md#submitselfserviceregistrationflow) | **POST** /api/kratos/public/self-service/registration | Submit a Registration Flow
*DefaultApi* | [**submitSelfServiceSettingsFlow**](doc//DefaultApi.md#submitselfservicesettingsflow) | **POST** /api/kratos/public/self-service/settings | Complete Settings Flow
*DefaultApi* | [**submitSelfServiceVerificationFlow**](doc//DefaultApi.md#submitselfserviceverificationflow) | **POST** /api/kratos/public/self-service/verification/methods/link | Complete Verification Flow
*DefaultApi* | [**toSession**](doc//DefaultApi.md#tosession) | **GET** /api/kratos/public/sessions/whoami | Check Who the Current HTTP Session Belongs To
*DefaultApi* | [**updateIdentityAdmin**](doc//DefaultApi.md#updateidentityadmin) | **PUT** /api/kratos/admin/identities/{id} | Update an Identity


## Documentation For Models

 - [AuthenticateOKBody](doc//AuthenticateOKBody.md)
 - [ContainerChangeResponseItem](doc//ContainerChangeResponseItem.md)
 - [ContainerCreateCreatedBody](doc//ContainerCreateCreatedBody.md)
 - [ContainerTopOKBody](doc//ContainerTopOKBody.md)
 - [ContainerUpdateOKBody](doc//ContainerUpdateOKBody.md)
 - [ContainerWaitOKBody](doc//ContainerWaitOKBody.md)
 - [ContainerWaitOKBodyError](doc//ContainerWaitOKBodyError.md)
 - [CreateIdentity](doc//CreateIdentity.md)
 - [CreateRecoveryLink](doc//CreateRecoveryLink.md)
 - [ErrorContainer](doc//ErrorContainer.md)
 - [ErrorResponse](doc//ErrorResponse.md)
 - [GenericError](doc//GenericError.md)
 - [GraphDriverData](doc//GraphDriverData.md)
 - [HealthNotReadyStatus](doc//HealthNotReadyStatus.md)
 - [HealthStatus](doc//HealthStatus.md)
 - [IdResponse](doc//IdResponse.md)
 - [Identity](doc//Identity.md)
 - [IdentityCredentials](doc//IdentityCredentials.md)
 - [ImageDeleteResponseItem](doc//ImageDeleteResponseItem.md)
 - [ImageSummary](doc//ImageSummary.md)
 - [InlineResponse200](doc//InlineResponse200.md)
 - [InlineResponse2001](doc//InlineResponse2001.md)
 - [InlineResponse503](doc//InlineResponse503.md)
 - [JsonError](doc//JsonError.md)
 - [LoginFlow](doc//LoginFlow.md)
 - [LoginViaApiResponse](doc//LoginViaApiResponse.md)
 - [Meta](doc//Meta.md)
 - [Plugin](doc//Plugin.md)
 - [PluginConfig](doc//PluginConfig.md)
 - [PluginConfigArgs](doc//PluginConfigArgs.md)
 - [PluginConfigInterface](doc//PluginConfigInterface.md)
 - [PluginConfigLinux](doc//PluginConfigLinux.md)
 - [PluginConfigNetwork](doc//PluginConfigNetwork.md)
 - [PluginConfigRootfs](doc//PluginConfigRootfs.md)
 - [PluginConfigUser](doc//PluginConfigUser.md)
 - [PluginDevice](doc//PluginDevice.md)
 - [PluginEnv](doc//PluginEnv.md)
 - [PluginInterfaceType](doc//PluginInterfaceType.md)
 - [PluginMount](doc//PluginMount.md)
 - [PluginSettings](doc//PluginSettings.md)
 - [Port](doc//Port.md)
 - [RecoveryAddress](doc//RecoveryAddress.md)
 - [RecoveryFlow](doc//RecoveryFlow.md)
 - [RecoveryLink](doc//RecoveryLink.md)
 - [RegistrationFlow](doc//RegistrationFlow.md)
 - [RegistrationViaApiResponse](doc//RegistrationViaApiResponse.md)
 - [RevokeSession](doc//RevokeSession.md)
 - [ServiceUpdateResponse](doc//ServiceUpdateResponse.md)
 - [Session](doc//Session.md)
 - [SettingsFlow](doc//SettingsFlow.md)
 - [SettingsProfileFormConfig](doc//SettingsProfileFormConfig.md)
 - [SettingsViaApiResponse](doc//SettingsViaApiResponse.md)
 - [SubmitSelfServiceBrowserSettingsOIDCFlowPayload](doc//SubmitSelfServiceBrowserSettingsOIDCFlowPayload.md)
 - [SubmitSelfServiceLoginFlow](doc//SubmitSelfServiceLoginFlow.md)
 - [SubmitSelfServiceLoginFlowWithPasswordMethod](doc//SubmitSelfServiceLoginFlowWithPasswordMethod.md)
 - [SubmitSelfServiceRecoveryFlowWithLinkMethod](doc//SubmitSelfServiceRecoveryFlowWithLinkMethod.md)
 - [SubmitSelfServiceRegistrationFlow](doc//SubmitSelfServiceRegistrationFlow.md)
 - [SubmitSelfServiceRegistrationFlowWithPasswordMethod](doc//SubmitSelfServiceRegistrationFlowWithPasswordMethod.md)
 - [SubmitSelfServiceSettingsFlow](doc//SubmitSelfServiceSettingsFlow.md)
 - [SubmitSelfServiceSettingsFlowWithPasswordMethod](doc//SubmitSelfServiceSettingsFlowWithPasswordMethod.md)
 - [SubmitSelfServiceSettingsFlowWithProfileMethod](doc//SubmitSelfServiceSettingsFlowWithProfileMethod.md)
 - [SubmitSelfServiceVerificationFlowWithLinkMethod](doc//SubmitSelfServiceVerificationFlowWithLinkMethod.md)
 - [UiContainer](doc//UiContainer.md)
 - [UiNode](doc//UiNode.md)
 - [UiNodeAnchorAttributes](doc//UiNodeAnchorAttributes.md)
 - [UiNodeAttributes](doc//UiNodeAttributes.md)
 - [UiNodeImageAttributes](doc//UiNodeImageAttributes.md)
 - [UiNodeInputAttributes](doc//UiNodeInputAttributes.md)
 - [UiNodeInputAttributesValue](doc//UiNodeInputAttributesValue.md)
 - [UiNodeTextAttributes](doc//UiNodeTextAttributes.md)
 - [UiText](doc//UiText.md)
 - [UpdateIdentity](doc//UpdateIdentity.md)
 - [VerifiableIdentityAddress](doc//VerifiableIdentityAddress.md)
 - [VerificationFlow](doc//VerificationFlow.md)
 - [Version](doc//Version.md)
 - [Volume](doc//Volume.md)
 - [VolumeUsageData](doc//VolumeUsageData.md)


## Documentation For Authorization


## oryToken

- **Type**: HTTP Bearer authentication

## sessionCookie

- **Type**: API key
- **API key parameter name**: ory_kratos_session
- **Location**: 

## sessionToken

- **Type**: HTTP Bearer authentication


## Author

support@ory.sh


